require "yaml"

class Config
  include YAML::Serializable

  property port : Int32 = 8090
  property db : String = "./db.sqlite3"
  property redisUrl : String = "127.0.0.1:6379"
  property log_level : LogLevel = LogLevel::Debug
  property key_expiration_time : Int32 = 60

  def self.load
    config_file = "./config.yml"
    config_yaml = File.read(config_file)
    config = Config.from_yaml(config_yaml)
    config
  end
end
