module Handlers
  extend self

  def parse_badges(env)
    badges_tuple = Providers.get_all_badges
    JSON.build do |j|
      j.object do
        j.field "chatterino" do
          j.object do
            j.field "badges" do
              j.array do
                badges_tuple[:chatterino]["badges"]?.try &.as_a.each do |item|
                  images = [item["image1"], item["image2"], item["image3"]]
                  j.object do
                    j.field "name", item["tooltip"]
                    j.field "urls" do
                      j.array do
                        images.each do |imageurl|
                          j.string imageurl
                        end
                      end
                    end
                    j.field "users", item["users"]
                  end
                end
              end
            end
          end
        end
        j.field "7tv" do
          j.object do
            j.field "badges" do
              j.array do
                badges_tuple[:seventv]?.try &.as_a.each do |item|
                  j.object do
                    j.field "name", item["type"]
                    j.field "url", item["url"]
                    j.field "users", item["users"]
                  end
                end
              end
              j.field "paints" do
                j.array do
                  badges_tuple[:seventv]?.try &.as_a.each do |item|
                    j.object do
                      j.field "name", item["type"]
                      j.field "url", item["url"]
                      j.field "users", item["users"]
                    end
                  end
                end
              end
            end
          end
          badge_id = [] of Int32
          badge_name = [] of String
          badge_url = [] of String
          badges_tuple[:bttv]?.try &.as_a.each do |item|
            if !badge_id.includes?(item["badge"]["type"])
              badge_id << item["badge"]["type"].to_s.to_i
              badge_name << item["badge"]["description"].to_s
              badge_url << item["badge"]["svg"].to_s
            end
          end
          badges = badge_id.zip(badge_name, badge_url)
          j.field "bttv" do
            j.object do
              j.field "badges" do
                j.array do
                  badges.each do |id, name, url|
                    j.object do
                      j.field "name", name
                      j.field "id", id
                      j.field "url", url
					  # TODO: En BTTV faltan los users xDD
                      j.field "users", "xd"
                    end
                  end
                end
              end
            end
          end
          j.field "ffz" do
            j.object do
              j.field "badges" do
                j.array do
                  badges_tuple[:ffz]?.try &.["badges"]?.try &.as_a.each do |item|
                    images = [item["urls"]["1"], item["urls"]["2"], item["urls"]["4"]]
                    j.object do
                      j.field "id", item["id"]
                    #   j.field "name", item["name"]
					# En FFZ remover "name" y que title sea el nuevo "name"
                      j.field "name", item["title"]
                      j.field "color", item["color"]
                      j.field "urls" do
                        j.array do
                          images.each do |imageurl|
                            j.string imageurl
                          end
                        end
                      end
                      j.field "users", badges_tuple[:ffz]["users"][item["id"].to_s]
                    end
                  end
                end
              end
            end
          end
          j.field "dankchat" do
            j.object do
              j.field "badges" do
                j.array do
                  badges_tuple[:dankchat]?.try &.as_a.each do |item|
                    j.object do
                      j.field "name", item["type"]
                      j.field "urls" do
                        j.array do
                          j.string item["url"]
                        end
                      end
                      j.field "users", item["users"]
                    end
                  end
                end
              end
            end
          end
          j.field "chatty" do
            j.object do
              j.field "badges" do
                j.array do
                  badges_tuple[:chatty]?.try &.as_a.each do |item|
                    # Chatty also returns the badges from FFZ, which is not needed since
                    # we already pull them directly from the api
                    next if item["id"] != "chatty"

					images = [item["image_url"], item["image_url_2"], item["image_url_4"]]
                    j.object do
                      j.field "name", item["meta_title"]?
                      # Zonian pidio que lo eliminara
                      #   j.field "badgeUrl", item["meta_url"]?
                      j.field "urls" do
                        j.array do
                          images.each do |imageurl|
                            j.string imageurl
                          end
                        end
                      end
                      j.field "users", item["usernames"]?
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
  end

  # 7TV
  def parse_7tv_badges(env)
    a = Providers::SevenTV.get_all_badges
    JSON.build do |j|
      j.object do
        j.field "badges", a["data"]["cosmetics"]["badges"]
      end
    end
  end

  def parse_7tv_paints(env)
    a = Providers::SevenTV.get_all_paints
    JSON.build do |j|
      j.object do
        j.field "paints", a["data"]["cosmetics"]["paints"]
      end
    end
  end

  def parse_7tv_user_cosmetics(env)
    user_id = env.params.url["user"]
    a = Providers::SevenTV.get_user_cosmetics(user_id)
    JSON.build do |j|
      j.object do
        j.field "badges", a["data"]["user"]["cosmetics"]
      end
    end
  end

  # MODULE END
end
