module Providers::SevenTV
  extend self

  def get_seventv_user_id(user_id : String)
    res = HTTP::Client.get("https://7tv.io/v3/users/twitch/#{user_id}", headers: HEADERS)
    JSON.parse(res.body)
  end

  def get_user_cosmetics(user_id : String)
    stored_used_id = SQL.query_one? "SELECT twitch_id FROM seventv_ids WHERE twitch_id = ? LIMIT 1;", user_id, as: String
    if user_id != stored_used_id
      stv_id = get_seventv_user_id(user_id)["user"]["id"].to_s
      SQL.exec "INSERT OR IGNORE INTO seventv_ids (twitch_id, seventv_id) VALUES (?, ?)", user_id, stv_id
    else
      stv_id =  SQL.query_one "SELECT seventv_id FROM seventv_ids WHERE twitch_id = ?", user_id, as: String
    end
    query = %q(
query GetUserCosmetics($id: ObjectID!) {
  user(id: $id) {
    id
    cosmetics {
      id
      kind
      selected
      __typename
    }
    __typename
  }
})
    data = JSON.build do |j|
      j.object do
        j.field "operationName", "GetUserCosmetics"
        j.field "variables" do
          j.object do
            j.field "id", stv_id
          end
        end
        j.field "query", query
      end
    end
    response = HTTP::Client.post("https://7tv.io/v3/gql",
      headers: HTTP::Headers{"Content-Type" => "application/json"},
      body: data)

    if response.success?
      JSON.parse(response.body)
    else
      raise "7tv is retarded: #{response.body}"
    end
  end

  def get_all_paints
    query = %q(
query GetCosmestics($list: [ObjectID!]) {
  cosmetics(list: $list) {
    paints {
      id
      kind
      name
      function
      color
      angle
      shape
      image_url
      repeat
      stops {
        at
        color
        __typename
      }
      shadows {
      x_offset
      y_offset
      radius
      color
      __typename
      }
    __typename
    }
  }
})
    data = JSON.build do |j|
      j.object do
        j.field "operationName", "GetCosmestics"
        j.field "query", query
      end
    end
    response = HTTP::Client.post("https://7tv.io/v3/gql",
      headers: HTTP::Headers{"Content-Type" => "application/json"},
      body: data)

    if response.success?
      JSON.parse(response.body)
    else
      raise "7tv is retarded: #{response.body}"
    end
  end

  def get_all_badges
    query = %q(
query GetCosmestics($list: [ObjectID!]) {
  cosmetics(list: $list) {
    badges {
      id
      kind
      name
      tooltip
      tag
      __typename
    }
  __typename
  }
})
    data = JSON.build do |j|
      j.object do
        j.field "operationName", "GetCosmestics"
        j.field "query", query
      end
    end
    response = HTTP::Client.post("https://7tv.io/v3/gql",
      headers: HTTP::Headers{"Content-Type" => "application/json"},
      body: data)

    if response.success?
      JSON.parse(response.body)
    else
      raise "7tv is retarded: #{response.body}"
    end
  end

  def get_badges(user_id : String)
    res = get_user_cosmetics(user_id)
    JSON.parse(res)
  end
end
