require "wait_group"

module Providers::Chatty
  extend self

  def get_badges
    res = HTTP::Client.get("https://tduva.com/res/badges", headers: HEADERS)
    res = postprocessing(JSON.parse(res.body))
    res
  end

  private def postprocessing(res) : JSON::Any
    users = 0

    # Counts the chatty supporters
    res.as_a.each do |item|
      next if item["id"] != "chatty"
      users += item["usernames"].size
    end

    wg = WaitGroup.new(users)

    res.as_a.each_with_index do |item, index|
      next if item["id"] != "chatty"

      item["usernames"].as_a.each_with_index do |username, index|
        if sql = SQL.query_one? "SELECT * FROM chatty_ids WHERE username = ? LIMIT 1", username.to_s, as: {String, String}
          item["usernames"].as_a[index] = JSON::Any.new(sql[1])
          puts "no"
          wg.done
          next
        end
        spawn do
          id = JSON::Any.new(Utils::GQL.new.get_user_id(username.to_s))
          SQL.exec "INSERT OR IGNORE INTO chatty_ids (username, twitch_id) VALUES (?, ?)", username.to_s, id.to_s
          item["usernames"].as_a[index] = id
        ensure
          wg.done
        end
      end
    end
    # Waits for all the fibers to complete before returning res
    wg.wait
    return res
  end
end
