class Utils::GQL
  private def req(query)
    headers = HTTP::Headers{
      "Content-Type" => "application/json",
      "Client-Id"    => "ue6666qo983tsx6so1t0vnawi233wa",
    }
    data = {"query" => query}
    response = HTTP::Client.post("https://gql.twitch.tv/gql", headers: headers, body: data.to_json)

    if response.success?
      response.body
    else
      raise "GQL Twitch API returned #{response.status_code}: #{response.body}"
    end
  end

  def get_user_id(username : String) : String | Nil
    query = %( query { user(login: "#{username}") { id } } )
	res = JSON.parse(req(query))
	return res["data"]["user"]["id"]?.try &.to_s
  end
end
