module Utils
  extend self

  def create_db
	# TODO: Check if the chatty table exists too!
    if !SQL.query_one "SELECT EXISTS (SELECT 1 FROM sqlite_schema WHERE type='table' AND name='seventv_ids')
		AND EXISTS (SELECT 1 FROM sqlite_schema WHERE type='table' AND name='seventv_ids');", as: Bool
      LOGGER.info "Creating sqlite3 database at '#{CONFIG.db}'"
      begin
        SQL.exec "CREATE TABLE IF NOT EXISTS seventv_ids (username text UNIQUE, twitch_id text UNIQUE, seventv_id text UNIQUE)"
        SQL.exec "CREATE TABLE IF NOT EXISTS chatty_ids (username text UNIQUE, twitch_id text UNIQUE)"
        # SQL.exec "CREATE TABLE IF NOT EXISTS #{CONFIG.ipTableName} (ip text UNIQUE, count integer DEFAULT 0, date integer)"
      rescue ex
        LOGGER.fatal "#{ex.message}"
        exit(1)
      end
    end
  end
end

module Utils::Redis
  extend self

  def getExpireTime(key)
    REDIS_DB.ttl(key)
  end

  def retrieveFromCache(keyName)
    if keyName && (json = REDIS_DB.get("#{Kemal.config.app_name}:#{keyName}"))
      return json
    end
  end

  def save(keyName, json_data : String, expiration = 60)
    REDIS_DB.set("#{Kemal.config.app_name}:#{keyName}", json_data, ex: expiration)
  end
end

